__author__ = "Zafer Aydin"
__date__ = "10/21/2009"
__project__ = "Protein Secondary Structure Prediction"

usage = """

        Usage: python compute_total_number_of_amino_acids.py <dataset dir> <observation filename root> <n_proteins> <laa> <output filename>
"""

import sys

if __name__ == "__main__":

        if (len(sys.argv) != 6):

                sys.stderr.write(usage)
                sys.exit(-1)

	dataset_dir = sys.argv[1]
	obs_root = sys.argv[2]
	n_proteins = int(sys.argv[3])
	laa = int(sys.argv[4])
	output_filename = sys.argv[5]

	total_n_aas = 0
	for i in range(n_proteins):

		input_filename = dataset_dir + obs_root + '_' + str(i+1) + '.obs'
		input_file = open(input_filename, 'r')
		input_file_inside = input_file.readlines()
		total_n_aas += (len(input_file_inside)-laa)
		input_file.close()

	output_file = open(output_filename, 'w')
	output_file.write('%d\n' % total_n_aas)
	output_file.close()
	
