__author__ = "Zafer Aydin"
__date__ = "10/18/2009"
__project__ = "Protein Secondary Structure Prediction"

usage = """

        Usage: python generate_accuracy_files2.py <iteration indices filename> <n proteins filename> <percentages filename> <n graphs> <output path> <output root> <matlab commandlines filename>
"""

import sys

if __name__ == "__main__":

   if (len(sys.argv) != 8):

      sys.stderr.write(usage)
      sys.exit(-1)

   iteration_indices_filename=sys.argv[1]
   n_proteins_filename = sys.argv[2]
   percentages_filename = sys.argv[3]
   n_graphs = int(sys.argv[4])	
   output_path = sys.argv[5]
   output_root = sys.argv[6]
   matlab_commandlines_filename = sys.argv[7]

   iteration_indices = []
   iteration_indices_file = open(iteration_indices_filename, 'r')
   iteration_indices_file_inside = iteration_indices_file.readlines()
   iteration_indices_file.close()

   n_iteration_indices = len(iteration_indices_file_inside)
 
   for i in range(n_iteration_indices):

      iteration_indices += [ int(iteration_indices_file_inside[i].rstrip()) ]

   n_proteins = []

   n_proteins_file = open(n_proteins_filename, 'r')
   n_proteins_file_inside = n_proteins_file.readlines()
   n_proteins_file.close()

   n_data = len(n_proteins_file_inside)

   for i in range(n_data):

      n_proteins += [ int(n_proteins_file_inside[i].rstrip()) ]

   percentages = []

   percentages_file = open(percentages_filename, 'r')
   percentages_file_inside = percentages_file.readlines()
   percentages_file.close()

   n_perc = len(percentages_file_inside)
	
   for i in range(n_perc):

      percentages += [ int(percentages_file_inside[i].rstrip()) ]

   matlab_commandlines_file = open(matlab_commandlines_filename, 'w')

   msd_filename = output_path + output_root + '_msd'
   mad_filename = output_path + output_root + '_mad'
   bla_filename = output_path + output_root + '_bla'

   msd_file = open(msd_filename, 'w')
   mad_file = open(mad_filename, 'w')
   bla_file = open(bla_filename, 'w')

   for it in range(n_iteration_indices):

      for q in range(n_graphs):

         for i in range(n_perc):

            msd_values = []
            mad_values = []
            bla_values = []

            for j in range(n_data):

               #accuracy_filename = output_path + output_root + '_' + str(n_proteins[j]) + '_proteins_perc_' + str(percentages[i]) + '_accuracies_q_' + str(q)

               accuracy_filename = output_path + output_root + '_it_' + str(iteration_indices[it]) + '_nproteins_' + str(n_proteins[j]) + '_perc_' + str(percentages[i]) + '_q_' + str(q)

               accuracy_file = open(accuracy_filename, 'r')
               accuracy_file_inside = accuracy_file.readlines()
               accuracy_file.close() 

               n_lines = len(accuracy_file_inside)

               for k in range(n_lines):
	
                  a_line = accuracy_file_inside[k].rstrip()

                  if ('Base Level Accuracy' in a_line):
			
                     token_list = a_line.split()
                     bla_values += [ float(token_list[-1]) ]

                  elif ('Mean Square Distance' in a_line):

                     token_list = a_line.split()
                     msd_values += [ float(token_list[-1]) ]

                  elif ('Mean L1 Norm Distance' in a_line):

                     token_list = a_line.split()
                     mad_values += [ float(token_list[-1]) ]

            for kk in range(n_data):

               msd_file.write('%s ' % msd_values[kk])
               mad_file.write('%s ' % mad_values[kk])
               bla_file.write('%s ' % bla_values[kk])

            msd_file.write('\n')
            mad_file.write('\n')
            bla_file.write('\n')

   msd_file.close()
   mad_file.close()
   bla_file.close()
		
   msd_filename_root = output_root + '_msd'
   mad_filename_root = output_root + '_mad'
   bla_filename_root = output_root + '_bla'
	
   matlab_commandlines_file.write('generate_accuracy_plots(' + '\'' + msd_filename_root + '\'' +' , ' + '\'' + msd_filename_root + '\'' + ')' + '\n')
   matlab_commandlines_file.write('generate_accuracy_plot(' + '\'' + mad_filename_root + '\'' + ', ' + '\'' + mad_filename_root + '\'' + ')' + '\n')
   matlab_commandlines_file.write('generate_accuracy_plot(' + '\'' + bla_filename_root + '\'' + ', ' + '\'' + bla_filename_root + '\'' + ')' + '\n')
	
   matlab_commandlines_file.close()
