__author__ = "Zafer Aydin"
__date__ = "10/14/2009"
__project__ = "Protein Secondary Structure Prediction"

usage = """

	Usage: python generate_dlink_difference_plots_accuracy_measures.py <laa> <fixed_params filename> <learned parameters filename> <fixed_params filename2> <learned parameters filename2> <output filename root discrete> <output filename root continuous> <output filename root accuracies> <output filename root minmax>
""" 

import sys

if __name__ == "__main__":

	if (len(sys.argv) != 10):

		sys.stderr.write(usage)
		sys.exit(-1)

	laa = int(sys.argv[1])
	fixed_params_filename = sys.argv[2]
	learned_params_filename = sys.argv[3]
	fixed_params_filename2 = sys.argv[4]
        learned_params_filename2 = sys.argv[5]
	output_filename_root_discrete = sys.argv[6]
	output_filename_root_continuous = sys.argv[7]
	output_filename_root_accuracies = sys.argv[8]
	output_filename_root_minmax = sys.argv[9]

	learned_params_file = open(learned_params_filename, 'r')
	learned_params_file_inside = learned_params_file.readlines()
	learned_params_file.close()	
	n_rows_learned_params = len(learned_params_file_inside)	
	a_line = learned_params_file_inside[2].rstrip()
	n_learned_graphs = int(a_line)

	learned_params_file2 = open(learned_params_filename2, 'r')
        learned_params_file_inside2 = learned_params_file2.readlines()
        learned_params_file2.close()      
        n_rows_learned_params2 = len(learned_params_file_inside2)
        a_line2 = learned_params_file_inside2[2].rstrip()
        n_learned_graphs2 = int(a_line2) 

	fixed_params_file = open(fixed_params_filename, 'r')
	a_line = fixed_params_file.readline().rstrip()
	number_of_graphs = int(a_line)
	a_line_to_skip = fixed_params_file.readline()

	fixed_params_file2 = open(fixed_params_filename2, 'r')
        a_line2 = fixed_params_file2.readline().rstrip()
        number_of_graphs2 = int(a_line2)
        a_line_to_skip2 = fixed_params_file2.readline()

	twenty_amino_acids = ['A', 'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I', 'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V']
		
	for i in range(number_of_graphs):

		a_line = fixed_params_file.readline().rstrip()
		graph_index = int(a_line)
		dlink_structure_name = fixed_params_file.readline().rstrip()
		a_line = fixed_params_file.readline().rstrip()
		n_dimensions = int(a_line)

		a_line2 = fixed_params_file2.readline().rstrip()
                graph_index2 = int(a_line2)
                dlink_structure_name2 = fixed_params_file2.readline().rstrip()
                a_line2 = fixed_params_file2.readline().rstrip()
                n_dimensions2 = int(a_line2)

		for jj in range(n_rows_learned_params):

			a_line = learned_params_file_inside[jj]

			if (a_line.startswith(dlink_structure_name)):			

				learned_dlink_coeff_start_index = jj+2
				break

		an_output_file = open(output_filename_root_discrete + '_q_' + str(i), 'w')
                an_output_file2 = open(output_filename_root_continuous + '_q_' + str(i), 'w')
                an_output_file3 = open(output_filename_root_accuracies + '_q_' + str(i), 'w')
                an_output_file4 = open(output_filename_root_minmax + '_q_' + str(i), 'w')

		#an_output_file = open(output_filename_root + '_discrete' + '_q_' + str(i), 'w')
		#an_output_file2 = open(output_filename_root + '_continuous' + '_q_' + str(i), 'w')
		#an_output_file3 = open(output_filename_root + '_accuracies' + '_q_' + str(i), 'w')
		#an_output_file4 = open(output_filename_root + '_minmax' + '_q_' + str(i), 'w')
	
		an_output_file3.write('Accuracy Measures q=%d\n' % i)

		#an_output_file3.write('<TABLE>\n')	

		true_positives = 0
		true_negatives = 0
		false_positives = 0
		false_negatives = 0
		mean_square_distance = 0.0
		L1_norm_distance = 0.0

		min_value=100000.0
		max_value=-100000.0

		an_output_file.write('Breadman\t')
		an_output_file2.write('Breadman\t')

		#Write the first row with labels to the output file
		total_n_columns = (laa+1)*n_dimensions

		for j in range(laa+1):

			for k in range(n_dimensions):

				temp_value = j-laa 
				an_output_file.write('t=' + str(temp_value) + ', ' + str(twenty_amino_acids[k]) + '\t')
				an_output_file2.write('t=' + str(temp_value) + ', ' + str(twenty_amino_acids[k]) + '\t')

		an_output_file.write('\n')
		an_output_file2.write('\n')

		#Initialize the dlink structure matrix to zeros
		dlink_structure = [0]*n_dimensions
		for j in range(n_dimensions):

			dlink_structure[j] = [0]*(laa+1)*n_dimensions
		
		dlink_structure2 = [0]*n_dimensions
                for j in range(n_dimensions):

                        dlink_structure2[j] = [0]*(laa+1)*n_dimensions2

		#Read the edges that are left in the sparse dlink structure
		for j in range(n_dimensions):

			a_line = fixed_params_file.readline().rstrip()
			token_list = a_line.split()

			a_line2 = fixed_params_file2.readline().rstrip()
                        token_list2 = a_line2.split()

			a_line3 = learned_params_file_inside[learned_dlink_coeff_start_index+j].rstrip()
			token_list3 = a_line3.split()

                        a_line4 = learned_params_file_inside2[learned_dlink_coeff_start_index+j].rstrip()
                        token_list4 = a_line4.split()

			n_edges = int(token_list[0])
			n_edges2 = int(token_list2[0])

			for k in range(n_edges):

				time_lag = int(token_list[2*k+1])
				edge_index = int(token_list[2*k+2])				
				matrix_index = (time_lag + laa)*n_dimensions + edge_index			
				dlink_structure[j][matrix_index] = float(token_list3[k+1])

			for k in range(n_edges2):

                                time_lag2 = int(token_list2[2*k+1])
                                edge_index2 = int(token_list2[2*k+2]) 
                                matrix_index2 = (time_lag2 + laa)*n_dimensions + edge_index2
                                dlink_structure2[j][matrix_index2] = float(token_list4[k+1])

		for j in range(n_dimensions):

                        an_output_file.write('t=' + str(0) + ', ' + str(twenty_amino_acids[j]) + '\t')
			an_output_file2.write('t=' + str(0) + ', ' + str(twenty_amino_acids[j]) + '\t')

			for k in range(total_n_columns):

				kk = k - (laa*n_dimensions)
				
				if ((kk >= 0) and (j >= kk)):

					an_output_file.write('%d\t' % 4)

				elif ((dlink_structure[j][k] != 0) and (dlink_structure2[j][k] != 0)):

					an_output_file.write('%d\t' % 0)
					true_positives += 1
					
				elif ((dlink_structure[j][k] != 0) and (dlink_structure2[j][k] == 0)):

                                        an_output_file.write('%d\t' % 1)
					false_negatives += 1

				elif ((dlink_structure[j][k] == 0) and (dlink_structure2[j][k] != 0)):

                                        an_output_file.write('%d\t' % 2)
					false_positives += 1

				elif ((dlink_structure[j][k] == 0) and (dlink_structure2[j][k] == 0)):

                                        an_output_file.write('%d\t' % 3)
					true_negatives += 1
					
				diff_value = dlink_structure[j][k] - dlink_structure2[j][k]

				if (diff_value > max_value):

					max_value = diff_value

				if (diff_value < min_value):

                                        min_value = diff_value

				mean_square_distance += diff_value*diff_value
				L1_norm_distance += abs(diff_value)

				if (diff_value == 0.0):

					an_output_file2.write('\t')
				else:
					an_output_file2.write('%.11f\t' % diff_value)

			an_output_file.write('\n')
			an_output_file2.write('\n')


		sensitivity = 100*float(true_positives) / float(true_positives + false_negatives)
		ppv = 100*float(true_positives) / float(true_positives + false_positives)
		base_level_accuracy = 100*float(true_positives + true_negatives) / float(true_positives + true_negatives + false_positives + false_negatives)

		total_n_edges_full_graph = laa*laa*n_dimensions + n_dimensions*(n_dimensions-1)/2.0 
		mean_square_distance = mean_square_distance / total_n_edges_full_graph
		mean_absolute_distance = L1_norm_distance / total_n_edges_full_graph

		an_output_file3.write('True Positives %d\n' % true_positives)
                an_output_file3.write('True Negatives %d\n' % true_negatives)
                an_output_file3.write('False Positives %d\n' % false_positives)
                an_output_file3.write('False Negatives %d\n' % false_negatives)
                an_output_file3.write('Sensitivity %.3f\n' % sensitivity)
                an_output_file3.write('Positive Predictive Value %.3f\n' % ppv)
                an_output_file3.write('Base Level Accuracy %.3f\n' % base_level_accuracy)
                an_output_file3.write('Mean Square Distance %.11f\n' % mean_square_distance)
                an_output_file3.write('Mean L1 Norm Distance %.11f\n' % mean_absolute_distance)
		
		#an_output_file3.write('<TR><TD> True Positives  <TD> %d\n' % true_positives)
		#an_output_file3.write('<TR><TD> True Negatives  <TD> %d\n' % true_negatives)
		#an_output_file3.write('<TR><TD> False Positives <TD> %d\n' % false_positives)
		#an_output_file3.write('<TR><TD> False Negatives <TD> %d\n' % false_negatives)
		#an_output_file3.write('<TR><TD> Sensitivity <TD> %.3f\n' % sensitivity)
		#an_output_file3.write('<TR><TD> Positive Predictive Value <TD> %.3f\n' % ppv)
		#an_output_file3.write('<TR><TD> Base Level Accuracy <TD> %.3f\n' % base_level_accuracy)
		#an_output_file3.write('<TR><TD> Mean Square Distance <TD> %.11f\n' % mean_square_distance)
		#an_output_file3.write('<TR><TD> Mean L1 Norm Distance <TD> %.11f\n' % mean_absolute_distance)
		#an_output_file3.write('</TABLE>\n')
		
		an_output_file4.write('%.11f\n' % min_value)
		an_output_file4.write('%.11f\n' % max_value)

		an_output_file.close()
		an_output_file2.close()			
		an_output_file3.close()
		an_output_file4.close()

		a_line = fixed_params_file.readline().rstrip()
		a_line2 = fixed_params_file2.readline().rstrip()

	fixed_params_file.close()
	fixed_params_file2.close()

