__author__ = "Zafer Aydin"
__date__ = "10/18/2009"
__project__ = "Protein Secondary Structure Prediction"

usage = """

        Usage: python generate_html_file.py <n proteins filename> <n amino acids filename> <percentages filename> <n graphs> <input full path (the path that contains images and accuracy files)> <input path2 (the path that contains images and accuracy files)> <input root (filename root for image and accuracy files)> <html output filename>
"""

import sys

if __name__ == "__main__":

   if (len(sys.argv) != 9):

      sys.stderr.write(usage)
      sys.exit(-1)

   n_proteins_filename = sys.argv[1]
   n_aas_filename = sys.argv[2]
   percentages_filename = sys.argv[3]
   n_graphs = int(sys.argv[4])
   input_path = sys.argv[5]
   input_path2 = sys.argv[6]
   input_root = sys.argv[7]
   html_output_filename = sys.argv[8]

   n_proteins = []

   n_proteins_file = open(n_proteins_filename, 'r')
   n_proteins_file_inside = n_proteins_file.readlines()
   n_proteins_file.close()

   n_data = len(n_proteins_file_inside)

   total_pixel_size = 900
   pixel_size_per_image = int(total_pixel_size/n_data)
   pixel_size_per_image2 = total_pixel_size / 9

   for i in range(n_data):

      n_proteins += [ int(n_proteins_file_inside[i].rstrip()) ]

   n_aas = []

   n_aas_file = open(n_aas_filename, 'r')
   n_aas_file_inside = n_aas_file.readlines()
   n_aas_file.close()

   for i in range(n_data):

      n_aas += [ int(n_aas_file_inside[i].rstrip()) ]

   percentages = []

   percentages_file = open(percentages_filename, 'r')
   percentages_file_inside = percentages_file.readlines()
   percentages_file.close()

   n_perc = len(percentages_file_inside)

   for i in range(n_perc):

      percentages += [ int(percentages_file_inside[i].rstrip()) ]
	
   output_file = open(html_output_filename, 'w')

   output_file.write("<html>\n")
   output_file.write("<body>\n")
   output_file.write("<blockquote>\n\n")

   for q in range(n_graphs):

      for i in range(n_perc):

         output_file.write("<TABLE align=\"centre\" border = \"1\">\n")
         output_file.write("<CAPTION><EM> %d%s elimination level, q=%d</EM></CAPTION>\n" % (percentages[i], '%', q))
         output_file.write("<TR><TD><center> %s synthetic chains" % '#')
         
         for j in range(n_data):

            output_file.write("<TD><center>%d" % n_proteins[j])

         output_file.write("\n")
         output_file.write("<TR><TD><center>difference plots\n\n")

         true_positives = []
         true_negatives = []
         false_positives = []
         false_negatives = []
         sensitivities = []
         positive_predictive_values = []
         base_level_accuracies = []
         mean_square_distances = []
         mean_absolute_distances = []
 
         for j in range(n_data):

            accuracy_filename = input_path + input_root + '_accuracies_it_' + str(1) + '_nproteins_' + str(n_proteins[j]) + '_perc_' + str(percentages[i]) + '_q_' + str(q)

            accuracy_file = open(accuracy_filename, 'r')
            accuracy_file_inside = accuracy_file.readlines()
            accuracy_file.close()

            n_lines = len(accuracy_file_inside)

            for k in range(n_lines):

               a_line = accuracy_file_inside[k].rstrip()

               if ('True Positives' in a_line):

                  token_list = a_line.split()
                  true_positives += [ float(token_list[-1]) ]

               elif ('True Negatives' in a_line):

                  token_list = a_line.split()
                  true_negatives += [ float(token_list[-1]) ] 

               elif ('False Positives' in a_line):

                  token_list = a_line.split()
                  false_positives += [ float(token_list[-1]) ] 

               elif ('False Negatives' in a_line):

                  token_list = a_line.split()
                  false_negatives += [ float(token_list[-1]) ] 

               elif ('Sensitivity' in a_line):

                  token_list = a_line.split()
                  sensitivities += [ float(token_list[-1]) ] 

               elif ('Positive Predictive Value' in a_line):

                  token_list = a_line.split()
                  positive_predictive_values += [ float(token_list[-1]) ] 

               elif ('Base Level Accuracy' in a_line):

                  token_list = a_line.split()
                  base_level_accuracies += [ float(token_list[-1]) ]

               elif ('Mean Square Distance' in a_line):

                  token_list = a_line.split()
                  mean_square_distances += [ float(token_list[-1]) ]  

               elif ('Mean L1 Norm Distance' in a_line):

                  token_list = a_line.split()
                  mean_absolute_distances +=  [ float(token_list[-1]) ] 

            image_filename_continuous = input_path2 + input_root + '_continuous_it_' + str(1) + '_nproteins_' + str(n_proteins[j]) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'

            output_file.write("<TD><center>\n")
            output_file.write("<TABLE>\n")
            output_file.write("<TR><TD><center>")
            output_file.write("<a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (image_filename_continuous, image_filename_continuous, pixel_size_per_image))
            output_file.write("<TR><TD><center>\n")
            output_file.write("<TABLE align=\"centre\">\n")
            output_file.write("<TR><TD><div align=\"center\"><font color=\"black\" size=\"2\"> MSD: </font> <TD> <div align=\"center\"><font color=\"black\" size=\"2\">%.11f</font>\n" % (mean_square_distances[j]))
            output_file.write("<TR><TD><div align=\"center\"><font color=\"black\" size=\"2\"> MAD: </font> <TD> <div align=\"center\"><font color=\"black\" size=\"2\">%.11f</font>\n" % (mean_absolute_distances[j]))
            output_file.write("</TABLE>\n")
            output_file.write("</TABLE>\n\n")

         if (percentages[i] == 0):
            output_file.write("</TABLE>\n\n")
            output_file.write("<br>\n")
            output_file.write("<TABLE align=\"centre\" border = \"1\">\n")
            output_file.write("<TR><TD><center>MSD vs %s aa's <TD><center>MAD vs %s aa's <TD><center> Multiple MSD vs %s aa's <TD><center> Multiple MAD vs %s aa's" % ('#', '#', '#', '#'))
            msd_filename = input_path2 + input_root + '_accuracies_msd_it_' + str(1) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
            mad_filename = input_path2 + input_root + '_accuracies_mad_it_' + str(1) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
            msd_means_stds_filename = input_path2 + input_root + '_accuracies_msd_mean_std' + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
            mad_means_stds_filename = input_path2 + input_root + '_accuracies_mad_mean_std' + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
            output_file.write("<TR><TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (msd_filename, msd_filename, pixel_size_per_image2))
            output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (mad_filename, mad_filename, pixel_size_per_image2))
            output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (msd_means_stds_filename, msd_means_stds_filename, pixel_size_per_image2))
            output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (mad_means_stds_filename, mad_means_stds_filename, pixel_size_per_image2))
            output_file.write("</TABLE>\n\n")
            output_file.write("<br><br>\n")
            continue

         output_file.write("<TR><TD><center>difference plots\n\n")         
         
         for j in range(n_data):

            image_filename_discrete = input_path2 + input_root + '_discrete_it_' + str(1) + '_nproteins_' + str(n_proteins[j]) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'

            output_file.write("<TD><center>\n")
            output_file.write("<TABLE>\n")
            output_file.write("<TR><TD><center>")
            output_file.write("<a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (image_filename_discrete, image_filename_discrete, pixel_size_per_image))
            output_file.write("<TR><TD><center>\n")
            output_file.write("<TABLE align=\"centre\">\n")
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> True Positives: </font> <TD>  <div align=\"right\"><font color=\"black\" size=\"2\">%d</font>\n" % (true_positives[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> True Negatives: </font> <TD>  <div align=\"right\"><font color=\"black\" size=\"2\">%d</font>\n" % (true_negatives[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> False Positives: </font> <TD> <div align=\"right\"><font color=\"black\" size=\"2\">%d</font>\n" % (false_positives[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> False Negatives: </font> <TD> <div align=\"right\"><font color=\"black\" size=\"2\">%d</font>\n" % (false_negatives[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> Sensitivity: </font> <TD> <div align=\"right\"><font color=\"black\" size=\"2\">%.2f</font>\n" % (sensitivities[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> PPV: </font> <TD> <div align=\"right\"><font color=\"black\" size=\"2\">%.2f</font>\n" % (positive_predictive_values[j]))
            output_file.write("<TR><TD><font color=\"black\" size=\"2\"> Accuracy: </font> <TD> <div align=\"right\"><font color=\"black\" size=\"2\">%.2f</font>\n" % (base_level_accuracies[j]))
            output_file.write("</TABLE>\n")
            output_file.write("</TABLE>\n\n")

         output_file.write("</TABLE>\n\n")
         output_file.write("<br>\n")
         output_file.write("<TABLE align=\"centre\" border = \"1\">\n")
         output_file.write("<TR><TD><center>MSD vs %s aa's <TD><center>MAD vs %s aa's <TD><center>Acc vs %s aa's <TD><center> Multiple MSD vs %s aa's <TD><center> Multiple MAD vs %s aa's <TD><center> Multiple Acc vs %s aa's\n" % ('#', '#', '#', '#', '#', '#'))
         msd_filename = input_path2 + input_root + '_accuracies_msd_it_' + str(1) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         mad_filename = input_path2 + input_root + '_accuracies_mad_it_' + str(1) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         bla_filename = input_path2 + input_root + '_accuracies_bla_it_' + str(1) + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         msd_means_stds_filename = input_path2 + input_root + '_accuracies_msd_mean_std' + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         mad_means_stds_filename = input_path2 + input_root + '_accuracies_mad_mean_std' + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         bla_means_stds_filename = input_path2 + input_root + '_accuracies_bla_mean_std' + '_perc_' + str(percentages[i]) + '_q_' + str(q) + '.png'
         output_file.write("<TR><TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (msd_filename, msd_filename, pixel_size_per_image2))
         output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (mad_filename, mad_filename, pixel_size_per_image2))
         output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (bla_filename, bla_filename, pixel_size_per_image2))
         output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (msd_means_stds_filename, msd_means_stds_filename, pixel_size_per_image2))
         output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (mad_means_stds_filename, mad_means_stds_filename, pixel_size_per_image2))
         output_file.write("<TD><center><a href = \"%s\"><IMG SRC=\"%s\" width=\"%d\"></a>\n" % (bla_means_stds_filename, bla_means_stds_filename, pixel_size_per_image2))
         output_file.write("</TABLE>\n\n")
         output_file.write("<br><br>\n")

   output_file.write("</blockquote>\n")
   output_file.write("</body>\n")
   output_file.write("</html>\n")
   output_file.close()

	
