__author__ = "Zafer Aydin"
__date__ = "01/13/2009"

# FILENAME: prepare_common_params_file_model13.py

usage="""

	python prepare_common_params_file_model13.py <models_dir> <weight_parameter>
"""

import sys

if __name__ == "__main__":

	if (len(sys.argv) != 3):

		sys.stderr.write(usage)
		sys.exit(-1) 

	models_dir=sys.argv[1]
	weight_value = float(sys.argv[2])
	common_params_filename = models_dir + 'common_params.txt'
	common_params_file = open(common_params_filename, 'w')
	common_params_file.write('#ifndef COMMON_PARAMS\n')
	common_params_file.write('#define COMMON_PARAMS\n\n')
	common_params_file.write('#define BINARY_CARD\t\t\t2\n')
	common_params_file.write('#define TRIPLE_CARD\t\t\t3\n')
	common_params_file.write('#define STATE_CARD\t\t\t3\n')
	common_params_file.write('#define MAX_STATE_LENGTH_CARD\t\t\t13\n')
	common_params_file.write('#define STATE_CLASS_HISTORY_CARD\t\t\t81\n')
	common_params_file.write('#define WEIGHT_AA_PROFILE\t\t\t'+str(weight_value)+'\n')
	common_params_file.write('#endif')
	common_params_file.write('\n')
	common_params_file.close()
