function [mean_shifts, U2s, covariances] = convert_gmtk_format_to_regular_means_covs(GMTK_means, GMTK_diag_covars, GMTK_dlinks, ngc, ndim, laa)

Bs = GMTK_dlinks; %not a square matrix in general
B1s = zeros(ndim, ndim, ngc); %i.e. Vqs
B2s = zeros(ndim, laa*ndim, ngc); % i.e. Jqs

U1s = zeros(ndim, ndim, ngc); %i.e. Uqs
U2s = zeros(ndim, ndim*laa, ngc); %i.e. Wqs
Ds = zeros(ndim, ndim, ngc);

GMTK_means = transpose(GMTK_means);
GMTK_diag_covars = transpose(GMTK_diag_covars);

for j = 1:ngc
	
	B1s(:,:,j) = Bs(:,1:ndim,j);
	B2s(:,:,j) = Bs(:,ndim+1:end, j);
	Ds(:,:,j) = inv(diag(GMTK_diag_covars(:,j)));
	U1s(:,:,j) = eye(ndim) - B1s(:,:,j);
	U2s(:,:,j) = inv(U1s(:,:,j))*B2s(:,:,j);
end

mean_shifts = zeros(ndim, ngc);
covariances = zeros(ndim, ndim, ngc);

for j = 1:ngc

	mean_shifts(:,j) = inv(U1s(:,:,j))*GMTK_means(:,j);
	covariances(:,:,j) = inv(U1s(:,:,j)'*Ds(:,:,j)*U1s(:,:,j));
end
