__author__ = "Zafer Aydin"
__date__ = "05/28/2009"

# FILE: find_weight_index_with_maximum_q3.py 
# PROJECT: Protein Secondary Structure Prediction

usage= """

	Usage: python find_weight_index_with_maximum_q3.py <q3 values filename> 
"""

import sys

if __name__ == "__main__":

	if (len(sys.argv) != 2):

		sys.stderr.write(usage)
		sys.exit(-1)

	q3_values_filename = sys.argv[1]
	#max_index_filename = sys.argv[2]

	q3_values_file = open(q3_values_filename, 'r')
	q3_values_file_inside = q3_values_file.readlines() 
	q3_values_file.close()

	max_q3 = 0.0
	max_index = 0

	for i in range(len(q3_values_file_inside)):

		#print q3_values_file_inside[i]
		q3_value = float(q3_values_file_inside[i].rstrip())
		
		if (q3_value > max_q3):

			max_q3 = q3_value
			max_index = i

	sys.exit(max_index)
