__author__ = "Zafer Aydin"
__date__ = "01/24/2009"

# FILENAME: generate_dlink_str_gcs2.py
# PROJECT: Protein Secondary Structure Prediction

usage="""

	Usage: generate_dlink_str_gcs2.py <number of dimensions> <starting index> <number of Gaussian components> <output filename>
"""
 
import sys
import random

if __name__ == "__main__":

	if ( len(sys.argv) != 5 ):

		sys.stderr.write(usage)
		sys.exit(-1)

	n_dimensions = int(sys.argv[1])
	starting_index = int(sys.argv[2])
	n_gc = int(sys.argv[3])
	output_filename = sys.argv[4]

	output_file = open(output_filename, 'w')

	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	
	for i in range(n_gc):

		output_file.write('%d' % i)
		output_file.write('\n')
		output_file.write('dlink_str' + str(i))
		output_file.write('\n')
		output_file.write('%d' % n_dimensions)
		output_file.write('\n')

		for j in range(n_dimensions):

			n_dependencies = starting_index - j
			#output_file.write(' ')
			output_file.write('%d' % n_dependencies)

			time_lag = 0
			feature_element_index = 1+j

			if (feature_element_index == n_dimensions):

	                	feature_element_index = 0
                        	time_lag -= 1

			for k in range(j, starting_index, 1):

				output_file.write('  ')
				output_file.write('%d' % time_lag )
				output_file.write('  ')	
				output_file.write('%d' % feature_element_index )
				feature_element_index += 1

				if (feature_element_index == n_dimensions):

					feature_element_index = 0
					time_lag -= 1		
		
			output_file.write('\n')

		output_file.write('\n')
	
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc):

		output_file.write(' ')		
		output_file.write('%d' % i)
		output_file.write('   ')
		output_file.write('%d' % n_dimensions)
		output_file.write('  ')
		output_file.write('%d' % 1)
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i)
		output_file.write('  ')
		output_file.write('meanEC')
		output_file.write('%d' % i)
                output_file.write('  ')
                output_file.write('covarEC')
                output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('dlink_mat')
                output_file.write('%d' % i)
		output_file.write('\n')

	output_file.write('\n')
	
	output_file.write('%d' % 1)
	output_file.write('\n')
	output_file.write('%d' % 0)
	output_file.write('    ')
	output_file.write('gmMxWt')
	output_file.write('    ')
	output_file.write('%d' % 1)
	output_file.write('    ')
	output_file.write('%f' % 1.0)
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc): 
                
                output_file.write(' ') 
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('%d' % n_dimensions) 
                output_file.write('  ')
		output_file.write('gmEC')
		output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('%d' % 1)
                output_file.write('  ')
		output_file.write('gmMxWt')
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i) 
                output_file.write('\n')

	output_file.write('\n')

	output_file.write('%d' % 1)
        output_file.write('\n\n')
        output_file.write('%d' % 0)
	output_file.write('\n')
	output_file.write('ECcollection')
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n')
	for i in range(n_gc):

		output_file.write('gmEC')
		output_file.write('%d' % i)
		output_file.write('\n')

	output_file.close()
	
 
