__author__ = "Zafer Aydin"
__date__ = "05/23/2009"

# FILENAME: generate_dlink_str_gcs_dlink_coeff_thr.py
# PROJECT: Protein Secondary Structure Prediction

usage="""

	Usage: python generate_dlink_str_gcs_dlink_coeff_thr.py <number of dimensions> <starting index> <number of Gaussian components> <dlink matrices filename> <threshold value> <n dlinks removed filename> <fixed_params_filename> <output filename> 
"""
 
import sys
import random

if __name__ == "__main__":

	if ( len(sys.argv) != 9 ):

		sys.stderr.write(usage)
		sys.exit(-1)

	n_dimensions = int(sys.argv[1])
	starting_index = int(sys.argv[2])
	n_gc = int(sys.argv[3])
	dlink_matrices_filename = sys.argv[4]
	threshold_value = float(sys.argv[5])
	n_dlinks_removed_filename = sys.argv[6]
	fixed_params_filename = sys.argv[7]
	output_filename = sys.argv[8]
	
	dlink_matrices_file = open(dlink_matrices_filename, 'r')

        line1 = dlink_matrices_file.readline()
        line2 = dlink_matrices_file.readline()
        n_dlink_mats_str = dlink_matrices_file.readline()
        n_dlink_mats_str = n_dlink_mats_str.rstrip()
        n_dlink_mats = int(n_dlink_mats_str)

	overall_percentage_dlinks_zeroed = 0
	
	fixed_params_file = open(fixed_params_filename, 'r')
	n_dlink_str = int(fixed_params_file.readline().rstrip())
		
	output_file = open(output_filename, 'w')
	output_file.write('%d' % n_dlink_mats)
	output_file.write('\n\n')

	total_n_dlinks_removed = 0

	for i in range(n_dlink_mats):

	        output_file.write('%d' % int(i))
        	output_file.write('\n')
      		output_file.write('dlink_str' + str(i))
        	output_file.write('\n')
        	output_file.write('%d' % n_dimensions)
        	output_file.write('\n')
		
		d_link_index =  int(dlink_matrices_file.readline().rstrip())
		dlink_mat_name = dlink_matrices_file.readline().rstrip()
                dlink_str_name = dlink_matrices_file.readline().rstrip()
                n_child_nodes = int(dlink_matrices_file.readline().rstrip())

		line1 = fixed_params_file.readline()
	        dlink_str_index = int(fixed_params_file.readline().rstrip())
        	dlink_str_name = fixed_params_file.readline().rstrip()
        	n_child_nodes_fixed_params = int(fixed_params_file.readline().rstrip())

		if (n_child_nodes != n_child_nodes_fixed_params):
		
			print 'Error: Number of child nodes in the learned dlink matrix is not equal to the one in the dlink structure'

		n_dlinks_zeroed = 0
                total_n_edges = 0

		for j in range(n_child_nodes):

			a_line = dlink_matrices_file.readline().rstrip()
                        token_list = a_line.split()
                        n_edges = int(token_list[0])
                        total_n_edges += n_edges

			a_line_fixed_params = fixed_params_file.readline().rstrip()
                        token_list_fixed_params = a_line_fixed_params.split()
                        n_edges_fixed_params = int(token_list_fixed_params[0])
		
			if (n_edges != n_edges_fixed_params):

				print 'Error: Number of edges are not the same in the learned dlink matrix and the dlink structure'
	
			n_dependencies = 0

			for k in range(n_edges):

                                dlink_value = float(token_list[k+1])
                                #print dlink_value

                                if (abs(dlink_value) < threshold_value):

					total_n_dlinks_removed += 1                                       
                                else:
					n_dependencies += 1

			output_file.write('%d' % n_dependencies)	

			for k in range(n_edges): 
 
                                dlink_value = float(token_list[k+1]) 
 
                                if (abs(dlink_value) >= threshold_value):

					output_file.write('  ')
                                	output_file.write('%d' % int(token_list_fixed_params[2*k+1]))
					output_file.write('  ')
					output_file.write('%d' % int(token_list_fixed_params[2*k+2]))       

                        output_file.write('\n')
	
		output_file.write('\n')
				
	output_file.write('\n')
	
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc):

		output_file.write(' ')		
		output_file.write('%d' % i)
		output_file.write('   ')
		output_file.write('%d' % n_dimensions)
		output_file.write('  ')
		output_file.write('%d' % 1)
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i)
		output_file.write('  ')
		output_file.write('meanEC')
		output_file.write('%d' % i)
                output_file.write('  ')
                output_file.write('covarEC')
                output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('dlink_mat')
                output_file.write('%d' % i)
		output_file.write('\n')

	output_file.write('\n')
	
	output_file.write('%d' % 1)
	output_file.write('\n')
	output_file.write('%d' % 0)
	output_file.write('    ')
	output_file.write('gmMxWt')
	output_file.write('    ')
	output_file.write('%d' % 1)
	output_file.write('    ')
	output_file.write('%f' % 1.0)
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc): 
                
                output_file.write(' ') 
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('%d' % n_dimensions) 
                output_file.write('  ')
		output_file.write('gmEC')
		output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('%d' % 1)
                output_file.write('  ')
		output_file.write('gmMxWt')
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i) 
                output_file.write('\n')

	output_file.write('\n')

	output_file.write('%d' % 1)
        output_file.write('\n\n')
        output_file.write('%d' % 0)
	output_file.write('\n')
	output_file.write('ECcollection')
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n')
	for i in range(n_gc):

		output_file.write('gmEC')
		output_file.write('%d' % i)
		output_file.write('\n')

	output_file.close()

	#print 'total number of dlinks removed = %d' % total_n_dlinks_removed
	n_dlinks_removed_file = open(n_dlinks_removed_filename, 'r')
	a_line = n_dlinks_removed_file.readline().rstrip()
	n_dlinks_removed_so_far = int(a_line)
	n_dlinks_removed_file.close()

	n_dlinks_removed_so_far += total_n_dlinks_removed
	
	n_dlinks_removed_file = open(n_dlinks_removed_filename, 'w')
	n_dlinks_removed_file.write('%d\n' % n_dlinks_removed_so_far)
	n_dlinks_removed_file.close()

	if (total_n_dlinks_removed == 0):

                sys.exit(2)
	
 
