__author__ = "Zafer Aydin"
__date__ = "01/20/2009"

# FILENAME: generate_initial_means_covars_dlink_matrices.py
# PROJECT: Protein Secondary Structure Prediction

usage="""

	Usage: generate_initial_means_covars_dlink_matrices.py <number of Gaussian components> <number of dimensions> <init_covariance> <starting_index> <output filename>
"""
 
import sys
import random

if __name__ == "__main__":

	if ( len(sys.argv) != 6 ):

		sys.stderr.write(usage)
		sys.exit(-1)

	n_gc = int(sys.argv[1])
	n_dimensions = int(sys.argv[2])
	init_covariance = float(sys.argv[3])
	starting_index = int(sys.argv[4])
	output_filename = sys.argv[5]

	output_file = open(output_filename, 'w')

	#Generate initial mean vectors
	output_file.write('%d' %n_gc)
        output_file.write('\n\n')

        for i in range(n_gc):

                output_file.write('  ')
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('meanEC')
                output_file.write(str(i))
                output_file.write('    ')
                output_file.write('%d' % n_dimensions)

                for j in range(n_dimensions):

                        output_file.write('   ')
                        #a_random_value = random.normalvariate(-1,0.3)
                        a_random_value = random.uniform(0,1.0)
                        output_file.write('%.3f' % a_random_value)

                output_file.write('\n')

	output_file.write('\n')

	#Generate initial diagonal entries of covariance matrix
        output_file.write('%d' %n_gc)
        output_file.write('\n\n')

        for i in range(n_gc):

                output_file.write('  ')
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('covarEC')
                output_file.write(str(i))
                output_file.write('    ')
                output_file.write('%d' % n_dimensions)

                for j in range(n_dimensions):

                        output_file.write('   ')
                        output_file.write('%.1f' % init_covariance)

                output_file.write('\n')

	output_file.write('\n')

	#Generate initial dlink matrices
	output_file.write('%d' %n_gc)
	output_file.write('\n')

	for i in range(n_gc):

		output_file.write('%d' % i)
		output_file.write('\n')
		output_file.write('dlink_mat')
		output_file.write('%d' % i)
		output_file.write('\n')
		output_file.write('dlink_str0')
		output_file.write('\n')
		output_file.write('%d' % n_dimensions)
		output_file.write('\n')

		for j in range(n_dimensions):

			n_dependencies = starting_index - j
			output_file.write('%d' % n_dependencies)
			output_file.write('  ')

			for k in range(n_dependencies):

				output_file.write('%.1f' % 0.0)
				output_file.write(' ')

			output_file.write('\n')

		output_file.write('\n')
	
	output_file.close()
	
 
