function length_cpt = generate_length_cpt(length_cpt_first_dmax_pos, exponential_tail_cpt, M, n_ss_labels, Dmax)

length_cpt = zeros(n_ss_labels, M);

for j=1:n_ss_labels %this is the secondary structure type

    for k=1:M
        
        if (k < Dmax)
           
            length_cpt(j,k) = length_cpt_first_dmax_pos(j,k);
            
        elseif (k == Dmax)
            
            da = exponential_tail_cpt(j,2); %probability of extending a segment in the exponential tail
            length_cpt(j,k) = length_cpt_first_dmax_pos(j,Dmax)*(1-da);

        else
            
            K=k-Dmax;
            da = exponential_tail_cpt(j,2);            
            length_cpt(j,k) = length_cpt_first_dmax_pos(j,Dmax)*(da^K)*(1-da);
        end
    end
end
