clear;
close all;

set(0,'defaultaxesfontsize',18);

for laa=5:5
    
    for lss=0:0
        
        filename = 'accuracy_perc_dlinks_removed_large_dataset_sparsity_alg_laa_';
        filename = strcat(filename, num2str(laa));
        filename = strcat(filename, '_lss_');
        filename = strcat(filename, num2str(lss));
        fid_accuracy = fopen(filename, 'r');
        
        if (fid_accuracy == -1)
            
            'Warning: the accuracy file does not exist for laa = '
            laa
            'lss = '
            lss
            continue;
        end
        
        done = 0;
        
        accuracies = [];
        percentages = [];
        
        line_number = 0;
        while (~done)
        
            a_line = fgetl(fid_accuracy)
            
            if (a_line == -1)
                done = 1;
                continue
            end
                
            [token, remainder] = strtok(a_line);
            accuracy = str2num(token);
            perc_dlinks_rem = str2num(remainder);
            line_number = line_number + 1;
            
            if ((perc_dlinks_rem == 0.0) && (line_number ~= 1))
               continue; 
            end
            
            accuracies = [accuracies, accuracy];
            percentages = [percentages, perc_dlinks_rem];
        end
        
        fclose(fid_accuracy);
        
        if (length(accuracies) > 0)
        
            figure; hold on;
            %set(gca,'XTick', percentages);
            axis_max = max(accuracies);
            axis_min = min(accuracies);
            axis([-3.0 103.0 (axis_min-0.5) (axis_max+0.5)]);
            percentages(19) = (percentages(18) + percentages(20))/2.0;
            plot(percentages, accuracies, 'b.-');
            %plot(percentage_values_laa_5_lss_3, q3_laa_5_lss_3, 'm.-'); legend('Laa=4 Lss=0', 'Laa=5 Lss=3', 'Location','SouthWest');
            xlabel('percentage of dlink coefficients zeroed'); ylabel('Acc(%)');

            image_filename = 'q3_dlink_perc_laa_';
            image_filename = strcat(image_filename, num2str(laa));
            image_filename = strcat(image_filename, '_lss_');
            image_filename = strcat(image_filename, num2str(lss));
            print(gcf, '-djpeg', image_filename);
            print(gcf, '-deps', image_filename);
            hold off;
            %close;
        end
    end
end