function covars = read_covar_vectors(learned_covars_filename, n_gc, n_dim)

covars = zeros(n_gc, n_dim);

fid_covars = fopen(learned_covars_filename, 'r');

if (fid_covars == -1)
   
    'Error opening the covars file'
end

done = 0;

while (~done)
   
    a_line = fgetl(fid_covars);
    
    if (a_line == -1)
       
        done = 1;
        continue;
    end
    
    if (~isempty(strfind(a_line, 'covar')))
        
        a_line = fgetl(fid_covars);
        n_covar_vecs = str2num(a_line);
        
        for j=1:n_covar_vecs
        
            a_line = fgetl(fid_covars);
            mean_index = str2num(a_line);
            
            a_line = fgetl(fid_covars);
            [token, remainder] = strtok(a_line);
            covar_vector_name = token;
            
            [token, remainder] = strtok(remainder);
            n_elements = str2num(token);
            
            for k=1:n_dim
                
                [token, remainder] = strtok(remainder);               
                covars(j, k) = str2num(token);
                
            end
        end
    end
end

fclose(fid_covars);
