function [start_length_cpt, length_cpt, state_transition_cpt, exponential_tail_cpt] = read_dense_cpts(learned_dense_cpts_filename)

fid_dense_cpts = fopen(learned_dense_cpts_filename, 'r');

if (fid_dense_cpts == -1)
   
    'Error opening the dlink matrices file'
end

done = 0;

while (~done)
   
    a_line = fgetl(fid_dense_cpts);
    
    if (a_line == -1)
       
        done = 1;
        continue;
    end
    
    if (~isempty(strfind(a_line, 'start_length_CPT')))
    
        a_line = fgetl(fid_dense_cpts);
        a_line = fgetl(fid_dense_cpts); % this should contain the cardinality information
        
        [token, remainder] = strtok(a_line);
        n_rows = str2num(token);
        [token, remainder] = strtok(remainder);
        n_cols = str2num(token);
        
        start_length_cpt = zeros(n_rows, n_cols);
        
        for j=1:n_rows
           
            a_line = fgetl(fid_dense_cpts);

            [token, remainder] = strtok(a_line);
            start_length_cpt(j, 1) = str2num(token);

            for k=2:n_cols
            
                [token, remainder] = strtok(remainder);
                start_length_cpt(j, k) = str2num(token);

            end
        end
    end
       
    if (~isempty(strfind(a_line, 'state_transition_CPT')))
        
        a_line = fgetl(fid_dense_cpts);
        a_line = fgetl(fid_dense_cpts); % this should contain the cardinality information
        
        [token, remainder] = strtok(a_line);
        n_rows = str2num(token);
        [token, remainder] = strtok(remainder);
        n_cols = str2num(token);

        state_transition_cpt = zeros(n_rows, n_cols);
        
        for j=1:n_rows
           
            a_line = fgetl(fid_dense_cpts);

            [token, remainder] = strtok(a_line);
            state_transition_cpt(j, 1) = str2num(token);

            for k=2:n_cols
            
                [token, remainder] = strtok(remainder);
                state_transition_cpt(j, k) = str2num(token);

            end
        end
    end
    
    if (~isempty(strfind(a_line, 'length_CPT')))
        
        a_line = fgetl(fid_dense_cpts);
        a_line = fgetl(fid_dense_cpts); % this should contain the cardinality information
        
        [token, remainder] = strtok(a_line);
        n_rows = str2num(token);
        [token, remainder] = strtok(remainder);
        n_cols = str2num(token);

        length_cpt = zeros(n_rows, n_cols);
        
        for j=1:n_rows
           
            a_line = fgetl(fid_dense_cpts);

            [token, remainder] = strtok(a_line);
            length_cpt(j, 1) = str2num(token);

            for k=2:n_cols
            
                [token, remainder] = strtok(remainder);
                length_cpt(j, k) = str2num(token);

            end
        end
    end

    if (~isempty(strfind(a_line, 'exponential_tail_CPT')))
        
        a_line = fgetl(fid_dense_cpts);
        a_line = fgetl(fid_dense_cpts); % this should contain the cardinality information
        
        [token, remainder] = strtok(a_line);
        n_rows_1 = str2num(token);
        [token, remainder] = strtok(remainder);
        n_rows_2 = str2num(token);
        n_rows = n_rows_1*n_rows_2;        
        [token, remainder] = strtok(remainder);
        n_cols = str2num(token);

        exponential_tail_cpt_large = zeros(n_rows, n_cols);
        
        for j=1:n_rows
           
            a_line = fgetl(fid_dense_cpts);

            [token, remainder] = strtok(a_line);
            exponential_tail_cpt_large(j, 1) = str2num(token);

            for k=2:n_cols
            
                [token, remainder] = strtok(remainder);
                exponential_tail_cpt_large(j, k) = str2num(token);
            end
        end
        
        exponential_tail_cpt = exponential_tail_cpt_large(37:39,12:13);
    end
end

fclose(fid_dense_cpts);
