function dlinks = read_dlink_matrices(learned_dlink_mats_filename, learned_dlink_structure_filename, n_gc, n_dim, laa)

n_cols = (laa+1)*n_dim;
%dlinks = zeros(n_gc, n_cols, n_dim);
dlinks = zeros(n_dim, n_cols, n_gc);

fid_dlink_mats = fopen(learned_dlink_mats_filename, 'r');
fid_dlink_struct = fopen(learned_dlink_structure_filename, 'r');

if (fid_dlink_mats == -1)
   
    'Error opening the dlink matrices file'
end

if (fid_dlink_struct == -1)
   
    'Error opening the dlink matrices file'
end

done = 0;

while (~done)
   
    a_line = fgetl(fid_dlink_mats);
    
    if (a_line == -1)
       
        done = 1;
        continue;
    end
    
    if (~isempty(strfind(a_line, 'dlink matrices')))
        
        a_line = fgetl(fid_dlink_mats);
        n_dlink_mats = str2num(a_line);
        
        a_line2 = fgetl(fid_dlink_struct);
        n_dlink_mats2 = str2num(a_line2);
    
        for j=1:n_dlink_mats
        
            a_line = fgetl(fid_dlink_mats);
            dlink_index = str2num(a_line);
            
            a_line = fgetl(fid_dlink_mats);
            dlink_mat_name = a_line;
            
            a_line = fgetl(fid_dlink_mats);
            dlink_struct_name = a_line;
            
            a_line = fgetl(fid_dlink_mats);
            n_dim2 = str2num(a_line);
            
            %skip a line first
            a_line2 = fgetl(fid_dlink_struct);
            
            a_line2 = fgetl(fid_dlink_struct);
            dlink_struct_index = str2num(a_line2);
            
            a_line2 = fgetl(fid_dlink_struct);
            dlink_struct_name = a_line2;
            
            a_line2 = fgetl(fid_dlink_struct);
            n_dim3 = str2num(a_line2);
                        
            for k=1:n_dim
            
                a_line = fgetl(fid_dlink_mats);
                [token, remainder] = strtok(a_line);
                n_dlinks_per_node = str2num(token);
        
                a_line2 = fgetl(fid_dlink_struct);
                [token2, remainder2] = strtok(a_line2);
                n_dlinks_per_node2 = str2num(token2);
        
                if (n_dlinks_per_node ~= n_dlinks_per_node2)
                
                    'Error the numbers of dlinks per node in your dlink matrices file and your dlink structure file are not the same'
                end
                
                for m=1:n_dlinks_per_node
                    
                    [token, remainder] = strtok(remainder);
                    dlink_value = str2num(token);
                    
                    [token2, remainder2] = strtok(remainder2);
                    time_lag = str2num(token2);
                    [token2, remainder2] = strtok(remainder2);
                    parent_index = str2num(token2);
                    
                    dlink_matrix_column_index = -1*time_lag*n_dim + parent_index + 1;
                    dlinks(k, dlink_matrix_column_index, j) = dlink_value;
                end                
            end
        end
    end
end

fclose(fid_dlink_mats);
fclose(fid_dlink_struct);
