function means = read_mean_vectors(learned_means_filename, n_gc, n_dim)

means = zeros(n_gc, n_dim);

fid_means = fopen(learned_means_filename, 'r');

if (fid_means == -1)
   
    'Error opening the means file'
end

done = 0;

while (~done)
   
    a_line = fgetl(fid_means);
    
    if (a_line == -1)
       
        done = 1;
        continue;
    end
    
    if (~isempty(strfind(a_line, 'mean')))
        
        a_line = fgetl(fid_means);
        n_mean_vecs = str2num(a_line);
        
        for j=1:n_mean_vecs
        
            a_line = fgetl(fid_means);
            mean_index = str2num(a_line);
            
            a_line = fgetl(fid_means);
            [token, remainder] = strtok(a_line);
            mean_vector_name = token;
            
            [token, remainder] = strtok(remainder);
            n_elements = str2num(token);
            
            for k=1:n_dim
                
                [token, remainder] = strtok(remainder);               
                means(j, k) = str2num(token);
                
            end
        end
    end
end

fclose(fid_means);
