#!/bin/bash
# FILE: runEM_yao.sh
# AUTHOR: Sheila Reynolds 
# DATE: 01/22/2009
# PROJECT: Protein Secondary Structure Prediction

if [ $# -ne 8 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins path> <number_of_cv_folds> <dataset_dir> <models_dir> <train_files_root> <number_of_profiles_to_skip> <max number of EM iterations>"
        exit 1
fi

gmtk_bins_path=$1
fold_index=$2
dataset_dir=$3
models_dir=$4
train_files_root=$5
n_skip=$6
reg_param=$7
max_n_iters=$8

#gmtkEMtrainNew \
#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkEMtrainNew \
${gmtk_bins_path}gmtkEMtrainNew \
		-strFile ${models_dir}model_train.str \
		-of1 $dataset_dir$train_files_root$fold_index.list -nf1 20 -ni1 3 -fmt1 ascii \
		-inputMasterFile ${models_dir}model_train_em_in.master \
		-outputMasterFile ${models_dir}model_train_em_out.master \
		-dirichletPriors T \
		-maxEmIters $max_n_iters \
		-objsNotToTrain ./nonTrainable.list \
		-varFloor 1.e-10 \
		-startSkip $n_skip \
		-gdarCoeffL2 $reg_param \	
		-lldp 0.00001 \
		-verbosity 19 
#-lldp 0.05
#-lldp 0.00001 \
#>& ./runEM.log


##============================================================================
