#!/bin/bash
# FILE: runEM_yao.sh
# AUTHOR: Sheila Reynolds 
# DATE: 01/22/2009
# PROJECT: Protein Secondary Structure Prediction

if [ $# -ne 8 ]
then
        echo ""
        echo "Usage: $0 <gmtk bins path> <fold index> <internal fold index> <dataset_dir> <models_dir> <train_files_root> <number_of_profiles_to_skip>"
        exit 1
fi

gmtk_bins_path=$1
fold_index=$2
internal_fold_index=$3
dataset_dir=$4
models_dir=$5
train_files_root=$6
n_skip=$7
reg_param=$8

#gmtkEMtrainNew \
#/net/noble/vol2/home/zafer/projects/pssp/gmtk/bin/x86_64/gmtkEMtrainNew \
${gmtk_bins_path}gmtkEMtrainNew \
		-strFile ${models_dir}model_train.str \
		-of1 $dataset_dir$train_files_root$fold_index$internal_fold_index.list -nf1 20 -ni1 3 -fmt1 ascii \
		-inputMasterFile ${models_dir}model_train_em_in.master \
		-outputMasterFile ${models_dir}model_train_em_out.master \
		-dirichletPriors T \
		-maxEmIters 100 \
		-objsNotToTrain ./nonTrainable.list \
		-varFloor 1.e-10 \
		-startSkip $n_skip \
		-gdarCoeffL2 $reg_param \
		-lldp 0.05 \
		-verbosity 19 
#>& ./runEM.log


##============================================================================
