#!/bin/bash
# FILE: runTrainTest_yao.sh
# AUTHOR: Zafer Aydin
# DATE: unknown
# PROJECT: Protein Secondary Structure Prediction with DBN Models

if [ $# -ne 35 ]
then
	echo ""
	echo "Usage: $0 <number_of_state_classes> <number_of_cv_folds> <dataset_dir> <scripts_dir> <models_dir> <train_files_root> <test_files_root> <test_postp_files_root> <reverse_model_root> <pssm_window_size> <ss window size> <output_html> <regularization parameter> <number of dimensions> <starting index for dlinks> <starting index1 for the timelag dependency for past profiles> <starting index2 for the timelag dependency for past profiles> <number of Gaussian componens> <initial covariance value> <fixed params file> <init trinable params file> <matlab dir> <mi_obs_data_output_filename_root> <mi tuple file root> <gmtk bins path> <w test files root> <w test postp files root> <w train files root> <n dlinks removed filename root> <weights filename root> <iteration index random> <iteration count up to> <perc_dlinks_to_be_eliminated_at_each_EM_it>" 
	echo "" 
	exit 1
fi
 
################################################################################

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
## now we are on to the TRAINING portion of the task ...

#echo " " 
#echo " "
#echo " STARTING BIG LOOP ... "
date

number_of_state_classes=$1
number_of_cv_folds=$2
dataset_dir=$3 
scripts_dir=$4
models_dir=$5
train_files_root=$6
test_files_root=$7
test_postp_files_root=$8
reverse_model_root=$9
pssm_window_size=${10}
ss_window_size=${11}
output_html=${12}
reg_param=${13}
ndim=${14}
starting_index=${15}
hist_starting_index1=${16}
hist_starting_index2=${17}
ngc=${18}
init_cov=${19}
fixed_params_filename=${20}
init_trainable_params_filename=${21}
matlab_dir=${22}
weight_opt_switch=${23}
diag_cov_addition_switch=${24}
mi_obs_data_output_filename_root=${25}
mi_tuple_file_root=${26}
gmtk_bins_path=${27}
w_test_files_root=${28}
w_test_postp_files_root=${29}
w_train_files_root=${30}
n_dlinks_removed_filename_root=${31}
weights_root=${32}
iteration_index_random=${33}
perc_dlinks_to_be_eliminated_at_each_EM_it=${34}
perc_dlinks_to_be_eliminated_total=${35}

learned_params_root="learned_params"
dump_names_root="dumpNames"
stop_iteration_flag=0

#Do for the forward model

#cat $dataset_dir${train_files_root}0.list $dataset_dir${test_files_root}0.list >& obs_files.list
#\cp obs_files.list $dataset_dir
\cp $dataset_dir${train_files_root}0.list ${dataset_dir}obs_files.list

n_dlinks_rem_filename=${n_dlinks_removed_filename_root}_laa_${pssm_window_size}_lss_${ss_window_size}_thr_$perc_dlinks_to_be_eliminated_total
\cp $dataset_dir$n_dlinks_removed_filename_root ./$n_dlinks_rem_filename

weights_filename=${weights_root}_laa_${pssm_window_size}_lss_${ss_window_size}_thr_$perc_dlinks_to_be_eliminated_total
\cp $dataset_dir$weights_root ./$weights_filename

#echo "number of dlinks removed filename = $n_dlinks_rem_filename"

#for (( fold_index = 0; fold_index < number_of_cv_folds; fold_index++))
for (( fold_index = 0; fold_index < 1; fold_index++))	
	do
        
		date
		echo $PWD

		# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		# SPARCIFY THE DLINK STRUCTURE (Past Dependency (NC) Model)
		
		#echo "CV-Fold=$fold_index  (Past Dependency (NC) Model)..."   

		w=1.0

		#Change the weight value in the common_params file
                python ${scripts_dir}prepare_common_params_file.py $models_dir $w

		python ${scripts_dir}generate_dlink_str_gcs2.py $ndim $starting_index $ngc $fixed_params_filename
                python ${scripts_dir}generate_initial_means_covars_dlink_matrices2.py $ngc $ndim $init_cov $starting_index $init_trainable_params_filename $pssm_window_size ${dataset_dir}obs_files.list	
		\cp $fixed_params_filename ${fixed_params_filename}_orig
		\cp $init_trainable_params_filename ${init_trainable_params_filename}_orig

		if [ "$perc_dlinks_to_be_eliminated_total" == "0" ]
		then
			max_em_iters=1
                        ${scripts_dir}runEM.sh $gmtk_bins_path $fold_index $dataset_dir $models_dir $train_files_root $pssm_window_size $reg_param $max_em_iters >& ./runEM.$fold_index.forward.log

			\cp ${models_dir}learnedParams.EM.dlinkMats.out0 ${models_dir}learnedParams.EM.dlinkMats.out
                        \cp ${models_dir}learnedParams.EM.covarVecs.out0 ${models_dir}learnedParams.EM.covarVecs.out
                        \cp ${models_dir}learnedParams.EM.denseCPTs.out0 ${models_dir}learnedParams.EM.denseCPTs.out
                        \cp ${models_dir}learnedParams.EM.meanVecs.out0 ${models_dir}learnedParams.EM.meanVecs.out
		fi

		n_iterations=`echo $perc_dlinks_to_be_eliminated_total/$perc_dlinks_to_be_eliminated_at_each_EM_it | bc`

		for (( iteration_count = 0; iteration_count < n_iterations; iteration_count++))
                do

			percentage=`echo $(($iteration_count+1))*$perc_dlinks_to_be_eliminated_at_each_EM_it | bc`
			perc_thr=$perc_dlinks_to_be_eliminated_at_each_EM_it #eliminate this many percentage of dlinks each time

			echo "total percentage of dlinks eliminated = $percentage"

			#echo "dlink iteration = $iteration_count"
			max_em_iters=1

			${scripts_dir}runEM.sh $gmtk_bins_path $fold_index $dataset_dir $models_dir $train_files_root $pssm_window_size $reg_param $max_em_iters >& ./runEM.$fold_index.forward.log

			\cp ${models_dir}$fixed_params_filename ${models_dir}${fixed_params_filename}_pre
        	        \cp ${models_dir}learnedParams.EM.dlinkMats.out0 ${models_dir}learnedParams.EM.dlinkMats.out
                	\cp ${models_dir}learnedParams.EM.covarVecs.out0 ${models_dir}learnedParams.EM.covarVecs.out
	                \cp ${models_dir}learnedParams.EM.denseCPTs.out0 ${models_dir}learnedParams.EM.denseCPTs.out
        	        \cp ${models_dir}learnedParams.EM.meanVecs.out0 ${models_dir}learnedParams.EM.meanVecs.out
			\cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_orig.out

			if [ "$iteration_count" == "0" ]
	                then
	
				\cp ${models_dir}$fixed_params_filename ${models_dir}${fixed_params_filename}_full_EM	
				\cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats.out_full_EM
                        	\cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs.out_full_EM
                        	\cp ${models_dir}learnedParams.EM.denseCPTs.out ${models_dir}learnedParams.EM.denseCPTs.out_full_EM
                        	\cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs.out_full_EM
			fi

			python ${scripts_dir}sparsify_dlink_structure_learned_dlink_values.py $ndim $starting_index $ngc ${models_dir}learnedParams.EM.dlinkMats_orig.out $perc_thr $n_dlinks_rem_filename ${fixed_params_filename}_pre $fixed_params_filename learnedParams.EM.dlinkMats.out
	
			#python ${scripts_dir}sparsify_dlink_structure_learned_dlink_values_rev.py $ndim $starting_index $ngc ${models_dir}learnedParams.EM.dlinkMats_orig.out $perc_thr $n_dlinks_rem_filename ${fixed_params_filename}_pre $fixed_params_filename learnedParams.EM.dlinkMats.out

			cat ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.dlinkMats.out >& $init_trainable_params_filename
			
			#\cp $init_trainable_params_filename ${init_trainable_params_filename}_$percentage
			#\cp $fixed_params_filename ${fixed_params_filename}_${percentage}_${percentage}_${percentage}
		done

		#Let EM converge
		max_em_iters=100
                ${scripts_dir}runEM.sh $gmtk_bins_path $fold_index $dataset_dir $models_dir $train_files_root $pssm_window_size $reg_param $max_em_iters >& ./runEM.$fold_index.forward.log

		#percentage=$((iteration_count_up_to*5))
		#percentage=$((iteration_count_up_to*perc_dlinks_to_be_eliminated_at_each_EM_it))
		percentage=$perc_dlinks_to_be_eliminated_total

                #Save the dlink structure and the learned parameters for dlink values at each iteration
                \cp ${models_dir}$fixed_params_filename ${models_dir}${fixed_params_filename}_${iteration_index_random}_$percentage
                \cp ${models_dir}learnedParams.EM.dlinkMats.out ${models_dir}learnedParams.EM.dlinkMats_${iteration_index_random}_$percentage.out
                \cp ${models_dir}learnedParams.EM.meanVecs.out ${models_dir}learnedParams.EM.meanVecs_${iteration_index_random}_$percentage.out
                \cp ${models_dir}learnedParams.EM.covarVecs.out ${models_dir}learnedParams.EM.covarVecs_${iteration_index_random}_$percentage.out
                \cp ${models_dir}learnedParams.EM.denseCPTs.out ${models_dir}learnedParams.EM.denseCPTs_${iteration_index_random}_$percentage.out

	done

echo " "
echo " COMPLETELY DONE !!! "
date

################################################################################
