__author__ = "Zafer Aydin"
__date__ = "10/13/2009"
__project__  = "Protein Secondary Structure Prediction"

usage="""

	Usage: python sparsify_dlink_structure_learned_dlink_values_rev.py <number of dimensions> <starting index> <number of Gaussian components> <learned dlink values filename> <threshold value> <n dlinks removed filename> <fixed_params_filename> <output fixed params filename> <output sparsified dlink values filename> 
"""
 
import sys
import random
import string
import operator
from operator import itemgetter

if __name__ == "__main__":

	if ( len(sys.argv) != 10 ):

		sys.stderr.write(usage)
		sys.exit(-1)

	n_dimensions = int(sys.argv[1])
	starting_index = int(sys.argv[2])
	n_gc = int(sys.argv[3])
	dlink_matrices_filename = sys.argv[4]
	perc_threshold = float(sys.argv[5])
	n_dlinks_removed_filename = sys.argv[6]
	fixed_params_filename = sys.argv[7]
	output_filename = sys.argv[8]
	output_filename2 = sys.argv[9]

	overall_percentage_dlinks_zeroed = 0

	total_n_dlinks_removed = 0

	dlinks_matrix = []
	total_n_dlinks = 0
	
	dlink_matrices_file = open(dlink_matrices_filename, 'r')

        line1 = dlink_matrices_file.readline()
        line2 = dlink_matrices_file.readline()
        n_dlink_mats_str = dlink_matrices_file.readline()
        n_dlink_mats_str = n_dlink_mats_str.rstrip()
        n_dlink_mats = int(n_dlink_mats_str)

	fixed_params_file = open(fixed_params_filename, 'r')
        n_dlink_str = int(fixed_params_file.readline().rstrip())

	#print n_dlink_mats

        output_file = open(output_filename, 'w')
        output_file.write('%d' % n_dlink_mats)
        output_file.write('\n\n')

	for i in range(n_dlink_mats):

                d_link_index =  int(dlink_matrices_file.readline().rstrip())
                dlink_mat_name = dlink_matrices_file.readline().rstrip()
                dlink_str_name = dlink_matrices_file.readline().rstrip()
                n_child_nodes = int(dlink_matrices_file.readline().rstrip())

                line1 = fixed_params_file.readline()
                dlink_str_index = int(fixed_params_file.readline().rstrip())
                dlink_str_name = fixed_params_file.readline().rstrip()
                n_child_nodes_fixed_params = int(fixed_params_file.readline().rstrip())

                if (n_child_nodes != n_child_nodes_fixed_params):

                        print 'Error: Number of child nodes in the learned dlink matrix is not equal to the one in the dlink structure'

                n_dlinks_zeroed = 0
                total_n_edges = 0

                for j in range(n_child_nodes):

                        a_line = dlink_matrices_file.readline().rstrip()
                        token_list = a_line.split()
                        n_edges = int(token_list[0])
                        total_n_edges += n_edges

                        a_line_fixed_params = fixed_params_file.readline().rstrip()
                        token_list_fixed_params = a_line_fixed_params.split()
                        n_edges_fixed_params = int(token_list_fixed_params[0])

                        if (n_edges != n_edges_fixed_params):

                                print 'Error: Number of edges are not the same in the learned dlink matrix and the dlink structure'

                        n_dependencies = 0

			for k in range(n_edges):

                                dlink_value = float(token_list[k+1])
                                #print dlink_value

	                        dlinks_matrix.append([0]*6)
	                        dlinks_matrix[total_n_dlinks][0] = i # the index of the dlink matrix (to indicate the ss tuple, e.g. H, E, L)
                        	dlinks_matrix[total_n_dlinks][1] = j # the row index of the dlink matrix
				dlinks_matrix[total_n_dlinks][2] = k # the column index of the dlink matrix
                        	dlinks_matrix[total_n_dlinks][3] = int(token_list_fixed_params[2*k+1]) # the time lag value of the dlink
				dlinks_matrix[total_n_dlinks][4] = int(token_list_fixed_params[2*k+2]) # the dlink index value of the dlink within the amino acid profile vector at a position
				dlinks_matrix[total_n_dlinks][5] = abs(dlink_value) # dlink value we will sort according to the absolute values of dlinks 
				total_n_dlinks += 1

		#print total_n_edges

	dlink_matrices_file.close()
	fixed_params_file.close()

	# Sort dlinks 
	just_dlink_values = map(itemgetter(5), dlinks_matrix)
	sorted_dlinks_bottom_to_top = sorted(enumerate(just_dlink_values), key=operator.itemgetter(1))
	sorted_dlinks_top_to_bottom = sorted_dlinks_bottom_to_top[::-1] # reverse the sorted list so that it's in descending order

	dlinks_to_be_removed = []
	#n_dlinks_to_be_removed = int(total_n_dlinks*perc_threshold / float(100))
	n_dlinks_to_be_removed = int(2190*3*perc_threshold / float(100))

	#print n_dlinks_to_be_removed

        dlink_matrices_file = open(dlink_matrices_filename, 'r')

        line1 = dlink_matrices_file.readline()
        line2 = dlink_matrices_file.readline()
        n_dlink_mats_str = dlink_matrices_file.readline()
        n_dlink_mats_str = n_dlink_mats_str.rstrip()
        n_dlink_mats = int(n_dlink_mats_str)

        output_file2 = open(output_filename2, 'w')

        output_file2.write(line1)
        output_file2.write(line2)
        output_file2.write(n_dlink_mats_str)
        output_file2.write('\n')

        fixed_params_file = open(fixed_params_filename, 'r')
        n_dlink_str = int(fixed_params_file.readline().rstrip())

	for i in range(n_dlinks_to_be_removed):

		dlink_index_in_pool = sorted_dlinks_top_to_bottom[total_n_dlinks-1-i][0]
		dlinks_to_be_removed.append(dlinks_matrix[dlink_index_in_pool])

	#print total_n_dlinks
	#print dlinks_to_be_removed

	for i in range(n_dlink_mats):

	        output_file.write('%d' % int(i))
        	output_file.write('\n')
      		output_file.write('dlink_str' + str(i))
        	output_file.write('\n')
        	output_file.write('%d' % n_dimensions)
        	output_file.write('\n')
		
		d_link_index =  int(dlink_matrices_file.readline().rstrip())
		dlink_mat_name = dlink_matrices_file.readline().rstrip()
                dlink_str_name = dlink_matrices_file.readline().rstrip()
                n_child_nodes = int(dlink_matrices_file.readline().rstrip())

		line1 = fixed_params_file.readline()
	        dlink_str_index = int(fixed_params_file.readline().rstrip())
        	dlink_str_name = fixed_params_file.readline().rstrip()
        	n_child_nodes_fixed_params = int(fixed_params_file.readline().rstrip())

                output_file2.write('%d\n' % d_link_index)
                output_file2.write('%s\n' % dlink_mat_name)
                output_file2.write('%s\n' % dlink_str_name)
                output_file2.write('%d\n' % n_child_nodes)

		if (n_child_nodes != n_child_nodes_fixed_params):
		
			print 'Error: Number of child nodes in the learned dlink matrix is not equal to the one in the dlink structure'

		n_dlinks_zeroed = 0
                total_n_edges = 0

		for j in range(n_child_nodes):

			a_line = dlink_matrices_file.readline().rstrip()
                        token_list = a_line.split()
                        n_edges = int(token_list[0])
                        total_n_edges += n_edges

			a_line_fixed_params = fixed_params_file.readline().rstrip()
                        token_list_fixed_params = a_line_fixed_params.split()
                        n_edges_fixed_params = int(token_list_fixed_params[0])
		
			if (n_edges != n_edges_fixed_params):

				print 'Error: Number of edges are not the same in the learned dlink matrix and the dlink structure'
	
			n_dependencies = 0

			for k in range(n_edges):

                                dlink_value = float(token_list[k+1])
                                #print dlink_value

				dlink_removal_flag = 0

				for kk in range(n_dlinks_to_be_removed):

					if ((dlinks_to_be_removed[kk][0] == i) and (dlinks_to_be_removed[kk][1] == j) and (dlinks_to_be_removed[kk][2] == k)):

						dlink_removal_flag = 1
						n_dependencies += 1

				if (dlink_removal_flag == 0):
					n_dependencies = n_dependencies						
					#n_dependencies += 1

			output_file.write('%d' % n_dependencies)	
			output_file2.write('%d ' % n_dependencies)

			for k in range(n_edges): 
 
                                dlink_value = float(token_list[k+1]) 
	
				dlink_removal_flag = 0
 
				for kk in range(n_dlinks_to_be_removed):

                                        if ((dlinks_to_be_removed[kk][0] == i) and (dlinks_to_be_removed[kk][1] == j) and (dlinks_to_be_removed[kk][2] == k)):

						dlink_removal_flag = 1

				if (dlink_removal_flag == 1):

					output_file.write('  ')
                                	output_file.write('%d' % int(token_list_fixed_params[2*k+1]))
					output_file.write('  ')
					output_file.write('%d' % int(token_list_fixed_params[2*k+2]))       
					output_file2.write('%.15f ' % dlink_value)

                        output_file.write('\n')
			output_file2.write('\n')
	
		output_file.write('\n')
				
	output_file.write('\n')
	
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc):

		output_file.write(' ')		
		output_file.write('%d' % i)
		output_file.write('   ')
		output_file.write('%d' % n_dimensions)
		output_file.write('  ')
		output_file.write('%d' % 1)
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i)
		output_file.write('  ')
		output_file.write('meanEC')
		output_file.write('%d' % i)
                output_file.write('  ')
                output_file.write('covarEC')
                output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('dlink_mat')
                output_file.write('%d' % i)
		output_file.write('\n')

	output_file.write('\n')
	
	output_file.write('%d' % 1)
	output_file.write('\n')
	output_file.write('%d' % 0)
	output_file.write('    ')
	output_file.write('gmMxWt')
	output_file.write('    ')
	output_file.write('%d' % 1)
	output_file.write('    ')
	output_file.write('%f' % 1.0)
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n\n')
	for i in range(n_gc): 
                
                output_file.write(' ') 
                output_file.write('%d' % i)
                output_file.write('   ')
                output_file.write('%d' % n_dimensions) 
                output_file.write('  ')
		output_file.write('gmEC')
		output_file.write('%d' % i)
                output_file.write('  ')
		output_file.write('%d' % 1)
                output_file.write('  ')
		output_file.write('gmMxWt')
		output_file.write('  ')
		output_file.write('gcEC')
		output_file.write('%d' % i) 
                output_file.write('\n')

	output_file.write('\n')

	output_file.write('%d' % 1)
        output_file.write('\n\n')
        output_file.write('%d' % 0)
	output_file.write('\n')
	output_file.write('ECcollection')
	output_file.write('\n')
	output_file.write('%d' % n_gc)
	output_file.write('\n')
	for i in range(n_gc):

		output_file.write('gmEC')
		output_file.write('%d' % i)
		output_file.write('\n')

	output_file.close()
	output_file2.write('\n')
	output_file2.close()

	dlink_matrices_file.close()
        fixed_params_file.close()

	#print 'total number of dlinks removed = %d' % total_n_dlinks_removed
	n_dlinks_removed_file = open(n_dlinks_removed_filename, 'r')
	a_line = n_dlinks_removed_file.readline().rstrip()
	n_dlinks_removed_so_far = int(a_line)
	n_dlinks_removed_file.close()

	n_dlinks_removed_so_far += total_n_dlinks_removed
	
	n_dlinks_removed_file = open(n_dlinks_removed_filename, 'w')
	n_dlinks_removed_file.write('%d\n' % n_dlinks_removed_so_far)
	n_dlinks_removed_file.close()

	if (total_n_dlinks_removed == 0):

                sys.exit(2)
	
 
