__author__ = "Zafer Aydin"
__date__ = "10/15/2009"
__project__ = "Protein Secondary Structure Prediction"

usage = """

        Usage: python submit_matrix2png_commands_continuous.py <matrix2png binary> <input filename> <minmax filename> <clip percentage matrix2png color scale bar> <png output filename>

"""

import sys
import os

if __name__ == "__main__":

        if (len(sys.argv) != 6):

                sys.stderr.write(usage)
                sys.exit(-1)

	matrix2png_binary = sys.argv[1]
	input_filename = sys.argv[2]
	minmax_filename = sys.argv[3]
	clip_perc = float(sys.argv[4])
	output_filename = sys.argv[5]

	minmax_file = open(minmax_filename, 'r')
	min_value = float(minmax_file.readline().rstrip())
	max_value = float(minmax_file.readline().rstrip())
	minmax_file.close()

	if (abs(min_value) > abs(max_value)):

		#stretch the maximum boundary
		max_value = -1*min_value

	elif ((min_value < 0) and (max_value > 0)):

		#stretch the minimum boundary
		min_value = -1*max_value

	min_value = min_value*(100.0-clip_perc) / float(100)
	max_value = max_value*(100.0-clip_perc) / float(100)
	
	os.system("%s -data %s -range %f%s%f -mincolor violet -maxcolor yellow -b -s -size 8:8 -r -c >& %s" % (matrix2png_binary, input_filename, min_value, ":", max_value, output_filename))

